package net.pricefx.common.api;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * Enumeration of existing FieldFormatTypes.
 */
public enum FieldFormatType {
	NUMERIC, NUMERIC_LONG, MONEY, PERCENT, TEXT, MONEY_EUR, MONEY_USD, MONEY_GBP, MONEY_JPY, MONEY_CHF, MONEY_PLN, DATETIME, DATE, INTEGER, LINK, COMPLEX, SPARKLINE;

	private static final Map<String,FieldFormatType> lookup = new HashMap<>();

	static {
	    for(FieldFormatType ft : EnumSet.allOf(FieldFormatType.class)){
	         lookup.put(ft.name(), ft);
	    }
	}

    public static FieldFormatType get(String code) {
        if(code == null) return null;
       	return lookup.get(code.toUpperCase());
    }
}
