package net.pricefx.common.api.chart;

import java.util.HashMap;
import java.util.Map;

public enum FilterOperator {

	EQUAL("equals"),
	NOT_EQUAL("notEqual"),

	LESS_THAN_OR_EQUAL_TO("lessOrEqual"),
	LESS_THAN("lessThan"),
	GREATER_THAN_OR_EQUAL_TO("greaterOrEqual"),
	GREATER_THAN("greaterThan"),

	CONTAINS("iContains"),
	DOES_NOT_CONTAIN("iNotContains"),
	ENDS_WITH("iEndsWith"),
	DOES_NOT_END_WITH("iNotEndsWith"),
	STARTS_WITH("iStartsWith"),
	DOES_NOT_START_WITH("iNotStartsWith"),

	IS_NULL("isNull"),
	NOT_NULL("notNull"),

	IN_SET("inSet"),
	NOT_IN_SET("notInSet"),

	AND("and"),
	OR("or"),
	NOT("not");

	private static final Map<String,FilterOperator> lookupViaName = new HashMap<>(FilterOperator.values().length + 1, 1);

	static {
		for(FilterOperator operator : FilterOperator.values()) {
			 lookupViaName.put(operator.name, operator);
		}

	}

	public static FilterOperator getViaName(String name) {
		return lookupViaName.get(name);
	}

	private String name;

	private FilterOperator(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

}

