package net.pricefx.common.apibuilder.clicoll;

import java.util.ArrayList;
import java.util.List;

import net.pricefx.common.api.InputType;
import net.pricefx.common.apibuilder.BuilderExtensions.GroovyDefaultImport;
import net.pricefx.common.apibuilder.clicoll.LineItemHelper.LineItem;
import net.pricefx.common.apibuilder.compensation.CompensationBuilder;
import net.pricefx.common.apibuilder.compensation.CompensationBuilderResult;
import net.pricefx.common.apibuilder.compensation.CompensationHelper;
import net.pricefx.common.apibuilder.contract.ContractBuilder;
import net.pricefx.common.apibuilder.contract.ContractHelper;
import net.pricefx.common.apibuilder.customform.CustomFormBuilderResult;
import net.pricefx.common.apibuilder.customform.CustomFormCollectionBuilder;
import net.pricefx.common.apibuilder.quote.QuoteBuilder;
import net.pricefx.common.apibuilder.quote.QuoteHelper;
import net.pricefx.common.apibuilder.rebateagreement.RATBuilder;
import net.pricefx.common.apibuilder.rebateagreement.RebateAgreementBuilder;
import net.pricefx.common.apibuilder.rebateagreement.RebateAgreementBuilderResult;
import net.pricefx.common.apibuilder.rebateagreement.RebateAgreementHelper;

public class CalculableLineItemCollectionExtensions {

	public static boolean isBuilderClass(Object o) {
		return
		o instanceof InputType ||
		o instanceof LineItem ||

		o instanceof QuoteBuilder ||
		o instanceof QuoteHelper ||
		o instanceof LineItemHelper ||

		o instanceof RebateAgreementBuilder||
		o instanceof RebateAgreementHelper||
		o instanceof CompensationBuilder ||
		o instanceof CompensationHelper ||
		o instanceof CompensationBuilderResult ||
		o instanceof ContractBuilder||
		o instanceof ContractHelper||

		o instanceof RATBuilder||
		o instanceof RATBuilder.RABuilder||
		o instanceof RebateAgreementBuilderResult ||

		o instanceof CustomFormCollectionBuilder ||
		o instanceof CustomFormBuilderResult
		;
	}

	public static List<GroovyDefaultImport> getGroovyDefaultImports() {
		ArrayList<GroovyDefaultImport> defaultImports = new ArrayList<GroovyDefaultImport>();
		defaultImports.add(new GroovyDefaultImport("InputType", InputType.class));
		return defaultImports;
	}

	// class.isInstance not supported by gwt compiler
	public static boolean isDefaultImport(Object o) {
		return (o instanceof InputType) ? true : false;
	}

	public static boolean isClass(Object o) {
		//cannot change this to isAssignable due to SGWT
		return o instanceof Class && InputType.class.getName().equals(((Class<?>)o).getName());
	}

}
