package net.pricefx.formulaengine.optimization;

import net.pricefx.formulaengine.DatamartContext;

import java.util.Map;

/**
 * @see net.pricefx.formulaengine.scripting.PublicGroovyAPI#model(String)
 */
public interface ModelContext {

    /**
     * @param evaluationName name of the evaluation in the model's class
     * @param inputs         inputs for executing the evaluation's formula
     * @return an unmodifiable ordered map of element name -&gt; result value
     */
    Map<String, Object> evaluate(String evaluationName, Map<String, Object> inputs);

    /**
     * @param name The table name in this model
     * @return The existing model table or {@code null} if it doesn't exist
     */
    DatamartContext.Table table(String name);

}
