package net.pricefx.formulaengine.optimization;

import net.pricefx.common.api.PriceFxInterface;

import java.util.Map;

/**
 * The {@link ModelParallelCalculationFormulaInitContext} is exposed to model parallel calculation logics through the <code>model</code> binding.
 */
public interface ModelParallelCalculationFormulaInitContext extends ModelFormulaContextReadWrite {
    /**
     * Add a calculation item to be calculated after the {@value PriceFxInterface#FORMULAELEMENTGROUP_MODEL_PARALLEL_CALCULATION_INIT}
     * context, during the {@value PriceFxInterface#FORMULAELEMENTGROUP_MODEL_PARALLEL_CALCULATION_ITEM} context.
     *
     * @param key    a key to uniquely identify the item in this parallel calculation
     * @param inputs inputs for the item calculation
     */
    void addCalculationItem(String key, Map<String, Object> inputs);
}
