package net.pricefx.logic.core.model;

import java.util.List;

import static net.pricefx.common.api.PriceFxInterface.*;

public abstract class AbstractFormulaElement extends BaseMapNullable implements Cloneable {

	public AbstractFormulaElement() {
		super();
	}

	public String getElementName() {
		return getStringValue(FIELD_FE_ELEMENTNAME);
	}

	public void setElementName(String elementName) {
		setStringValue(FIELD_FE_ELEMENTNAME, elementName);
	}

	public String getElementLabel() {
		return getStringValue(FIELD_FE_ELEMENTLABEL);
	}

	public void setElementLabel(String elementLabel) {
		setStringValue(FIELD_FE_ELEMENTLABEL, elementLabel);
	}

	public String getFormulaExpression() {
		return getStringValue(FIELD_FE_FORMULAEXPRESSION);
	}

	public void setFormulaExpression(String formulaExpression) {
		setStringValue(FIELD_FE_FORMULAEXPRESSION, formulaExpression);
	}

	public String getElementDescription() {
		return getStringValue(FIELD_FE_ELEMENTDESC);
	}

	public void setElementDescription(String elementDescription) {
		setStringValue(FIELD_FE_ELEMENTDESC, elementDescription);
	}

	public Boolean getHideWarnings() {
		return Boolean.TRUE.equals(getBooleanValue(FIELD_FE_HIDEWARNINGS));
	}

	public void setHideWarnings(Boolean hideWarnings) {
		setBooleanValue(FIELD_FE_HIDEWARNINGS, hideWarnings);
	}

	public Boolean getProtectedExpression() {
		return Boolean.TRUE.equals(getBooleanValue(FIELD_FE_PROTECTEDEXPRESSION));
	}

	public void setProtectedExpression(Boolean protectedExpression) {
		setBooleanValue(FIELD_FE_PROTECTEDEXPRESSION, protectedExpression);
	}

	public List<String> getElementGroups() {
		return getListValue(FIELD_FE_ELEMENTGROUPS);
	}

	public void setElementGroups(List<String> elementGroups) {
		setListValue(FIELD_FE_ELEMENTGROUPS, elementGroups);
	}

	public String getConditionElementName() {
		return getStringValue(FIELD_FE_ELEMENTCONDITION);
	}

	public void setConditionElementName(String conditionElementName) {
		setStringValue(FIELD_FE_ELEMENTCONDITION, conditionElementName);
	}

	public String getCombinationType() {
		return getStringValue(FIELD_FE_COMBINATIONTYPE);
	}

	public void setCombinationType(String combinationType) {
		setStringValue(FIELD_FE_COMBINATIONTYPE, combinationType);
	}

	public Integer getElementTimeout() {
		return getIntValue(FIELD_FE_ELEMENTTIMEOUT);
	}

	public void setElementTimeout(Integer elementTimeout) {
		setIntegerValue(FIELD_FE_ELEMENTTIMEOUT, elementTimeout);
	}

	public Boolean getExcludeFromExport() {
		return Boolean.TRUE.equals(getBooleanValue(FIELD_FE_EXCLUDEFROMEXPORT));
	}

	public void setExcludeFromExport(Boolean excludeFromExport) {
		setBooleanValue(FIELD_FE_EXCLUDEFROMEXPORT, excludeFromExport);
	}

/*	String getTypedId();
	void setTypedId(String typedId);

	String getCreateDate();
	void setCreateDate(String createDate);

	Long getCreatedBy();
	void setCreatedBy(Long createdBy);

	String getLastUpdateDate();
	void setLastUpdateDate(String lastUpdateDate);

	Long getLastUpdateBy();
	void setLastUpdateBy(Long lastUpdateBy);

	Long getVersion();
	void setVersion(Long version);*/
}
